# Copyright (c) 2016, Patrick Uiterwijk <patrick@puiterwijk.org>
# All rights reserved.
#
# This file is part of Basset.
#
# Basset is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Basset is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Basset.  If not, see <http://www.gnu.org/licenses/>.

from basset.score.base import ScorePlugin


class ContentScore(ScorePlugin):
    name = 'content'

    def get_score(self, action, time, data):
        scores = {}

        scores['title'] = self._get_title_score(data['page']['title'])

        return scores

    def _get_title_score(self, title):
        title = title.replace(' ', '_').lower()
        mapping = {}
        for option in self.config:
            if option.startswith('title_'):
                title = option[len('title_'):].lower()
                mapping[title] = self.config[option]
                mapping['.'.join(title)] = self.config[option]
                mapping['..'.join(title)] = self.config[option]

        total_score = 0
        for word in mapping:
            if word in title:
                total_score += int(mapping[word])
        return total_score
